//
//  ItemResModel.m
//  uPnp2
//
//  Created by rk on 26/03/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "ItemResModel.h"


@implementation ItemResModel

@synthesize size, resolution, protocolInfo, mimeType, colorDepth, url;


-(id)initWithGDataXMLElement:(GDataXMLElement *)theElement {
	self = [super init];
//    NSLog(@"itemRes XML: %@", [theElement XMLString]);
    resolution = [[theElement attributeForName:@"resolution"] stringValue];
    protocolInfo = [[theElement attributeForName:@"protocolInfo"] stringValue];
    mimeType = [ItemResModel mimeTypeFromProtocolInfo:protocolInfo];
	url = [theElement stringValue];
    size = [[[theElement attributeForName:@"size"] stringValue] intValue];
    colorDepth = [[[theElement attributeForName:@"colorDepth"] stringValue] intValue];
    
	return self;
}

// lower case MimeType string
+(NSString *)mimeTypeFromProtocolInfo:(NSString *)protocolInfoString {
    if (protocolInfoString == nil) return nil;
    NSArray *components = [protocolInfoString componentsSeparatedByString:@":"];
    if (components.count < 3) return nil;
    NSString *result = [components objectAtIndex:2];
    result = [result lowercaseString];
    return result;    
}

-(bool)isImage {
    if (mimeType == nil) return false;
    NSRange srch = [mimeType rangeOfString:@"image/"];
    if (srch.length == NSNotFound) return false;
    if (srch.location == 0) return true;
    return false;
}

-(bool) isVideo {
    if (mimeType == nil) return false;
    NSRange srch = [mimeType rangeOfString:@"video/"];
    if (srch.length == NSNotFound) return false;
    if (srch.location == 0) return true;
    return false;
}


-(void)dealloc {
    [resolution release];
    [protocolInfo release];
    [mimeType release];
    [url release];
    [super dealloc];
}


@end
