//
//  UpnpAvContentDirectoryItem.m
//  uPnp2
//
//  Created by rk on 11/03/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "UpnpAvContentDirectoryItemModel.h"


@implementation UpnpAvContentDirectoryItemModel

@synthesize title, albumArtUri, iconUri, icon, resItems;

-(id)initWithGDataXMLElement:(GDataXMLElement *)theElement {
	self = [super init];
    NSLog(@"\n\n  item XML:\n %@\n\n", [theElement XMLString]);
	//title = [UpnpAvContentDirectoryItemModel stringFromXmlElement:theElement :@"dc:title"];
	title = [UpnpAvContentDirectoryItemModel stringFromXmlElement:theElement :@"dc:title"];
    albumArtUri = [UpnpAvContentDirectoryItemModel stringFromXmlElement:theElement :@"upnp:albumArtURI"];
    upnpClassString = [UpnpAvContentDirectoryItemModel stringFromXmlElement:theElement :@"upnp:class"];
    NSLog(@"  albumArtUri: '%@', upnpClassString: '%@'", albumArtUri, upnpClassString);
    NSArray *elementResItems = [theElement elementsForName:@"res"];
    NSMutableArray *resItemArray = [[NSMutableArray alloc] initWithCapacity:10];
    for (GDataXMLNode *resItem in elementResItems) {
        [resItemArray addObject:[[ItemResModel alloc] 
                                 initWithGDataXMLElement:(GDataXMLElement *) resItem]];
    }
    if (resItemArray.count > 0) {
        resItems = resItemArray;
        for (int i=0; i< resItemArray.count; i++) {
            ItemResModel *itemRes = [resItemArray objectAtIndex:i];
            if (itemRes.isImage) {
                iconUri = itemRes.url;
                break;
            }
        }
    }
    
	return self;
}

-(ItemType)itemType {
    ItemType result = Unknown;
    if([upnpClassString isEqualToString:ImageItemTypeString]){
        result = Image;
    }
    if([upnpClassString isEqualToString:VideoItemTypeString]){
        result = Video;
    }
    return result;
}



-(void)dealloc {
    [icon release];
    [title release];
    [albumArtUri release];
    [upnpClassString release];
    [resItems release];
    [super dealloc];
}
@end
