//
//  UpnpAvContentDirectoryService.h
//  uPnp2
//
//  Created by rk on 10/03/11.
//  Copyright 2011 Interchart. All rights reserved.
//


#import <Foundation/Foundation.h>
#import "UpnpDevice.h"
#import "UpnpAvService.h"
#import "UpnpHttpServer.h"

@protocol ContainerContentHandlerDelegate <NSObject>

@optional
-(void)getContainerContentHandler:(NSArray *)containers: (NSArray *)items;
@end


@interface UpnpAvContentDirectoryService : NSObject <AsynchUpnpCommandDelegate>{
	UpnpAvService *service;
	id getContainerContentDelegate;
}

@property (readonly) UpnpHttpServer *httpServer;

-(id)initWithService:(UpnpAvService *)theService;
-(void)getContainerContent:(NSString *)containerId: (id)delegate;
-(void)fetchResource:(NSString *)resourceUri;


#pragma mark AsynchUpnpCommandDelegate methods
- (void)handleAsynchUpnpCommandResult:(GDataXMLDocument *)parsedResult;

#pragma mark Private methods
-(void)doGetContainerContentCommand:(NSString *)containerId;
-(void)doExportResourceCommand:(NSString *)sourceUri : (NSString *)destUri; 
@end
