//
//  UpnpAvXmlFetchable.m
//  uPnp2
//
//  Created by rk on 1/02/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "UpnpAvXmlFetchable.h"


@implementation UpnpAvXmlFetchable

// Override this method in subclasses. Here we do nothing.
-(void)handleParsedXml:(GDataXMLDocument *)parsedXml {
	
}

-(void) fetchXmlFromDevice:(NSURL *)deviceUrl: (NSString *)relativeUrlString {
	NSURL *actualUrl = [[NSURL alloc] initWithString:relativeUrlString relativeToURL:deviceUrl];
	
	NSURLRequest *request = [NSURLRequest 
							 requestWithURL:actualUrl 
							 cachePolicy:NSURLRequestReloadIgnoringCacheData 
							 timeoutInterval:30];
	[readData release];
	readData = [[NSMutableData alloc] init];
    
	//NSURLConnection *conn = 
	[[NSURLConnection alloc] initWithRequest:request
									delegate:self
							startImmediately:YES];	
}

//This method will be called several times as the data arrives
- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[readData appendData: data];
}

- (void) connectionDidFinishLoading:(NSURLConnection *)connection {
	NSLog(@"%@", [Util dataToString:readData]);
    NSError *error;
    parsedXml = [[GDataXMLDocument alloc] initWithData:readData options:0 error:&error ];
	if ([self respondsToSelector:@selector(handleParsedXml:)]) {
        [self handleParsedXml:parsedXml];
	}
    
	[readData release];
	readData = [[NSMutableData alloc] init]; // ready for next read
    
}


@end
